<template>
  <div @click="close" :class="{ screen: true, opened }"></div>
  <div :class="{ editor: true, opened }">
    <div class="form" v-if="component_data.props">
      <div
        v-for="(group, groupName) in component_data.props"
        :key="groupName"
        :class="{ group: true, opened: openedGroups.includes(groupName) }"
      >
        <span
          class="groupName"
          @click="
            () => {
              openedGroups.includes(groupName)
                ? openedGroups.splice(
                    openedGroups.findIndex((el) => el == groupName),
                    1
                  )
                : openedGroups.push(groupName);
            }
          "
          >{{ groupName }}</span
        >
        <div class="props">
          <div v-for="prop in group" :key="prop.key" class="prop">
            <span>{{ prop.label || prop.key }}</span>
            <input
              v-if="prop.type === 'String'"
              type="text"
              v-model="component_data.data.props[prop.key]"
            />
            <input
              v-if="prop.type === 'Number'"
              type="text"
              v-model="component_data.data.props[prop.key]"
            />
            <input
              v-if="prop.type === 'Boolean'"
              type="checkbox"
              v-model="component_data.data.props[prop.key]"
            />
            <div class="ArrayEdit" v-if="prop.type === 'ArrayOfObj'">
              <div
                v-for="(item, itemIndex) in component_data.data.props[prop.key]"
                :key="itemIndex"
                class="arrayItem"
              >
                <div class="inputsGroup">
                  <div
                    class="arrayField"
                    v-for="(field, fieldIndex) in prop.structure"
                    :key="fieldIndex"
                  >
                    <span>{{ field.label || field.key }}</span>
                    <input
                      type="text"
                      v-model="
                        component_data.data.props[prop.key][itemIndex][field.key]
                      "
                    />
                  </div>
                </div>
                <div class="deleteItem">
                  <Icon
                    src="delete"
                    size="32px"
                    color="var(--color)"
                    @click="()=>{component_data.data.props[prop.key].splice(itemIndex, 1)}"
                  />
                </div>
              </div>
              <button
                @click="
                  () => {
                    addItemToArrOfObj(component_data.data.props[prop.key], prop.structure);
                  }
                "
                class="addItem"
              >
                <Icon src="plus" size="32px" color="var(--color)" />
              </button>
            </div>
            <trumbowyg
              v-if="prop.type === 'HtmlText'"
              v-model="component_data.data.props[prop.key]"
              :config="HtmlConfig"
              class="form-control"
              name="content"
            ></trumbowyg>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import site_components from "sc/index";
import { computed, reactive, ref, watchEffect } from "vue";
import Icon from "ac/Icon";
export default {
  components: {
    Icon,
    ...site_components.sections,
  },
  props: ["opened", "onClose", "data", "component", "onSave"],
  setup(props) {
    const saved = ref(false);
    const openedGroups = ref([]);

    const item = computed(() => {
      return site_components.sections[props.component];
    });

    const component_data = reactive({
      props: {},
      data: {
        props: {
          ...props.data,
        },
      },
    });

    watchEffect(() => {
      saved.value = false;
      openedGroups.value = [];
      const props_raw = props.component
        ? Object.assign({}, site_components.sections[props.component].props)
        : {};

      const groups = {};
      Object.keys(props_raw).forEach((key) => {
        if (groups[props_raw[key].group || "settings"] == undefined) {
          groups[props_raw[key].group || "settings"] = [];
        }

        groups[props_raw[key].group || "settings"].push({
          key,
          type: props_raw[key].editType,
          label: props_raw[key].label,
          structure: props_raw[key].fields
        });
      });

      component_data.props = groups;
      component_data.data.props =
        props.data && props.data.props ? { ...props.data.props } : {};
    });

    const HtmlConfig = {
      btns: [
        ["formatting"],
        ["strong"],
        ["link"],
        ["unorderedList", "orderedList"],
        ["removeformat"],
      ],
      removeformatPasted: true,
      tagsToRemove: ["script", "link"],
      autogrow: false,
    };

    return {
      item,
      component_data,
      saved,
      HtmlConfig,
      openedGroups,
    };
  },
  methods: {
    close() {
      if (this.saved) {
        this.onClose();
      } else {
        this.save();
        this.onClose();
      }
    },
    save() {
      this.onSave(this.component_data.data);
      this.component_data.data = Object.assign({}, this.component_data.data);
      this.saved = true;
    },
    addItemToArrOfObj(arr, fields) {
      arr.push(
        Object.fromEntries(fields.map(field=>field.key).map(key=>([key, ""])))
      );
    },
  },
};
</script>

<style scoped lang="scss">
.editor {
  overflow-y: auto;
  z-index: 8;
  padding: 8px;
  position: fixed;
  left: 44px;
  top: 44px;
  height: calc(100vh - 44px);
  background: #ffffff;
  width: 400px;
  transform: translateX(-100%);
  transition: 0.3s ease all;

  &.opened {
    transform: translateX(0);
  }
}

.navBarExpanded {
  .editor {
    left: 200px;
  }
}

.screen {
  z-index: 7;
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  right: 0;
  background: #00000040;
  opacity: 0;
  transition: 0.3s ease all;
  pointer-events: none;
  &.opened {
    opacity: 1;
    pointer-events: all;
  }
}

.form {
  display: block;
  margin-top: 16px;
}

.group {
  display: block;
  width: 100%;
  border-radius: 5px;
  border: 1px solid #00000050;
  margin-bottom: 10px;
  transition: all 0.5s ease;
  max-height: 50px;
  overflow: hidden;

  .props {
    padding: 12px;
  }

  &.opened {
    max-height: 600px;
    overflow: auto;
  }
  .groupName {
    cursor: pointer;
    height: 50px;
    align-items: center;
    justify-content: center;
    display: flex;
    color: var(--primary-color);
    margin-bottom: 8px;
    text-align: center;
    font-size: 21px;
  }
}

.itemName {
  color: var(--primary-color);
}

.prop {
  display: flex;
  flex-direction: column;
  align-items: flex-start;
  width: 100%;

  &:not(:last-child) {
    margin-bottom: 10px;
  }

  span {
    display: block;
    margin-right: 8px;
    width: 100%;
    font-size: 16px;
    margin-bottom: 4px;
  }

  input {
    width: auto;
    align-self: start;
    margin: 0;
    border-radius: 4px;
    border: 1px solid #00000050;

    &:not([type="checkbox"]) {
      width: 100%;
      padding: 0.5em 0.8em;
    }
  }
}

.ArrayEdit {
  display: flex;
  flex-direction: column;
  width: 100%;

  .addItem {
    background: var(--primary-color);
    border: none;
    outline: none;
    border-radius: 4px;
    display: flex;
    align-items: center;
    justify-content: center;

    --color: white;
  }

  .deleteItem {
    display: flex;
    align-items: center;
    justify-content: center;
    align-self: flex-start;
    height: auto !important;
    background: transparent;
    border: 2px solid var(--secondary-color);
    margin-left: 8px;
    --color: var(--secondary-color);
    border-radius: 4px;
    transition: 0.3s ease all;


    
    &:hover {
      background: var(--secondary-color);
      --color: white;
    }

    &:active {
      background: var(--secondary-dark-1-color);
      --color: white;
    }
  }

  > .arrayItem {
    display: flex;
    flex-direction: row;
    &:not(:last-child) {
      margin-bottom: 16px;
    }

    .inputsGroup{
      flex: 1;
    }


    .arrayField {
      &:not(:last-child) {
        margin-bottom: 4px;
      }
      display: flex;
      align-items: center;
      > *:nth-child(1) {
        flex: 0.3;
        font-size: 14px;
      }
      > *:nth-child(2) {
        flex: 0.7;
        width: 100%;
      }
    }
  }
}
</style>
